// Code generated by gobind. DO NOT EDIT.

// Java class com.proton.gopenpgp.crypto.SessionKey is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=com.proton.gopenpgp github.com/ProtonMail/gopenpgp/v2/crypto
package com.proton.gopenpgp.crypto;

import go.Seq;

/**
 * SessionKey stores a decrypted session key.
 */
public final class SessionKey implements Seq.Proxy {
	static { Crypto.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	public SessionKey(byte[] token, String algo) {
		this.refnum = __NewSessionKeyFromToken(token, algo);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewSessionKeyFromToken(byte[] token, String algo);
	
	SessionKey(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * The decrypted binary session key.
	 */
	public final native byte[] getKey();
	/**
	 * The decrypted binary session key.
	 */
	public final native void setKey(byte[] v);
	
	/**
	 * The symmetric encryption algorithm used with this key.
	 */
	public final native String getAlgo();
	/**
	 * The symmetric encryption algorithm used with this key.
	 */
	public final native void setAlgo(String v);
	
	public native boolean clear();
	/**
	 * Decrypt decrypts pgp data packets using directly a session key.
	* encrypted: PGPMessage.
	* output: PlainMessage.
	 */
	public native PlainMessage decrypt(byte[] dataPacket) throws Exception;
	/**
	 * DecryptAndVerify decrypts pgp data packets using directly a session key and verifies embedded signatures.
	* encrypted: PGPMessage.
	* verifyKeyRing: KeyRing with verification public keys
	* verifyTime: when should the signature be valid, as timestamp. If 0 time verification is disabled.
	* output: PlainMessage.
	 */
	public native PlainMessage decryptAndVerify(byte[] dataPacket, KeyRing verifyKeyRing, long verifyTime) throws Exception;
	/**
	 * DecryptStream is used to decrypt a data packet as a Reader.
	It takes a reader for the data packet
	and returns a PlainMessageReader for the plaintext data.
	If verifyKeyRing is not nil, PlainMessageReader.VerifySignature() will
	verify the embedded signature with the given key ring and verification time.
	 */
	public native PlainMessageReader decryptStream(Reader dataPacketReader, KeyRing verifyKeyRing, long verifyTime) throws Exception;
	/**
	 * Encrypt encrypts a PlainMessage to PGPMessage with a SessionKey.
	* message : The plain data as a PlainMessage.
	* output  : The encrypted data as PGPMessage.
	 */
	public native byte[] encrypt(PlainMessage message) throws Exception;
	/**
	 * EncryptAndSign encrypts a PlainMessage to PGPMessage with a SessionKey and signs it with a Private key.
	* message : The plain data as a PlainMessage.
	* signKeyRing: The KeyRing to sign the message
	* output  : The encrypted data as PGPMessage.
	 */
	public native byte[] encryptAndSign(PlainMessage message, KeyRing signKeyRing) throws Exception;
	/**
	 * EncryptStream is used to encrypt data as a Writer.
	It takes a writer for the encrypted data packet and returns a writer for the plaintext data.
	If signKeyRing is not nil, it is used to do an embedded signature.
	 */
	public native WriteCloser encryptStream(Writer dataPacketWriter, PlainMessageMetadata plainMessageMetadata, KeyRing signKeyRing) throws Exception;
	/**
	 * EncryptWithCompression encrypts with compression support a PlainMessage to PGPMessage with a SessionKey.
	* message : The plain data as a PlainMessage.
	* output  : The encrypted data as PGPMessage.
	 */
	public native byte[] encryptWithCompression(PlainMessage message) throws Exception;
	/**
	 * GetBase64Key returns the session key as base64 encoded string.
	 */
	public native String getBase64Key();
	// skipped method SessionKey.GetCipherFunc with unsupported parameter or return types
	
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof SessionKey)) {
		    return false;
		}
		SessionKey that = (SessionKey)o;
		byte[] thisKey = getKey();
		byte[] thatKey = that.getKey();
		if (thisKey == null) {
			if (thatKey != null) {
			    return false;
			}
		} else if (!thisKey.equals(thatKey)) {
		    return false;
		}
		String thisAlgo = getAlgo();
		String thatAlgo = that.getAlgo();
		if (thisAlgo == null) {
			if (thatAlgo != null) {
			    return false;
			}
		} else if (!thisAlgo.equals(thatAlgo)) {
		    return false;
		}
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {getKey(), getAlgo()});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("SessionKey").append("{");
		b.append("Key:").append(getKey()).append(",");
		b.append("Algo:").append(getAlgo()).append(",");
		return b.append("}").toString();
	}
}

